<?php
defined('_JEXEC') or die('Restricted access');

class modYouTubeHelper {
	
	function getVideos($params) {
	
		$height	= $params->get('height', '355');
		$width	= $params->get('width', '425');
		$thumbheight	= $params->get('thumbheight', '97');
		$thumbwidth	= $params->get('thumbwidth', '130');
		$divwidth	= $params->get('divwidth', '128');
		$autoplay	= $params->get('autoplay', '1');
		$shadowbox = $params->get('shadowbox', '1');
		$display = $params->get('display', '2');
		$layout = $params->get('layout', '0');
		
		$container = $layout ? 'yt_container_horizontal' : "yt_container_vertical";
		$params->set('container', $container);
		
		$divwidth = $divwidth."px";
		$params->set('divwidth', $divwidth);
		
		$document = JFactory::getDocument();
		
		if ($shadowbox) {
			$adapter = 'modules/mod_tjs_youtube/shadowbox/src/js/adapter/shadowbox-mootools.js';
			$document->addScript($adapter);
			
			$shadowbox = 'modules/mod_tjs_youtube/shadowbox/src/js/shadowbox.js';
			$document->addScript($shadowbox);
		}
		$stylesheet = 'modules/mod_tjs_youtube/shadowbox/src/css/shadowbox.css';
		$document->addStylesheet($stylesheet);
		
		$stylesheet = 'modules/mod_tjs_youtube/mod_tjs_youtube.css';
		$document->addStylesheet($stylesheet);
		
		$feed = modYouTubeHelper::getFeed($params);
		$xml = simplexml_load_file($feed);
		
		$videos = array();
		$i = 0;
		foreach ($xml->entry as $entry) {
			$media = $entry->children('http://search.yahoo.com/mrss/');
			
			  // get video player URL		  
			  if ($shadowbox && $media->group->content) {
				$attrs = $media->group->content->attributes();
				$watch = $attrs['url'];
				$rel = "rel=shadowbox;width=".$width.";height=".$height;
			  } else {
				$attrs = $media->group->player->attributes();
				$watch = $attrs['url'];
				$rel = "target='_blank'";
			  }

			  // get video thumbnail
			  $attrs = $media->group->thumbnail[0]->attributes();
			  $thumbnail = $attrs['url'];
			  
			  $yt = $media->children('http://gdata.youtube.com/schemas/2007');
			  $attrs = $yt->duration->attributes();
			  $length = $attrs['seconds'];
			  $minutes = floor($length/60);
			  $seconds = ($length%60 < 10) ? '0'.($length%60) : ($length%60);
			  $length = $minutes.":".$seconds;
			  
			  // get <yt:stats> node for viewer statistics
			  $yt = $entry->children('http://gdata.youtube.com/schemas/2007');
			  $attrs = $yt->statistics->attributes();
			  $viewCount = $attrs['viewCount']; 
			  
			  // get <gd:rating> node for video ratings
			  $gd = $entry->children('http://schemas.google.com/g/2005'); 
			  if ($gd->rating) {
				$attrs = $gd->rating->attributes();
				$rating = $attrs['average']; 
			  } else {
				$rating = 0; 
			  } 

					
			$videos[$i]['title'] = null;
			$videos[$i]['thumbnail'] = null;
			
		
			$videos[$i]['title'] .= "<span class='extube_title'>";            
			$videos[$i]['title'] .= "<a href='".$watch."&amp;autoplay=".$autoplay."' ".$rel.">".$media->group->title."</a>";
			$videos[$i]['title'] .= "</span>";
		
			$videos[$i]['thumbnail'] .= "<span class='video_thm'><a href='".$watch."&amp;autoplay=".$autoplay."' ".$rel.">";
			$videos[$i]['thumbnail'] .= "<img src='".$thumbnail."' class='extube_thumb' width='".$thumbwidth."' height='".$thumbheight."' />";
			$videos[$i]['thumbnail'] .= "</a></span>";
			
			$videos[$i]['author'] = $entry->author->name;
			$videos[$i]['duration'] = $length;
			$videos[$i]['rating'] = $rating;
			$videos[$i]['viewCount'] =$viewCount;
				
		$i++;
		}
		return $videos;
	
	}
	
	function getFeed($params) {
		$type = $params->get('feedtype', '0');
		$count	= $params->get('count', '5');
		$youtubeid = $params->get('youtubeid','');
		$standardfeed = $params->get('standardfeed', '');
		$region = $params->get('region', '');
		$category = $params->get('category', '');


		if ($type == '1') :
			
			$feed = 'http://gdata.youtube.com/feeds/api/users/'.$youtubeid.'/uploads?max-results='.$count;
		
		else :
		
			$feed = 'http://gdata.youtube.com/feeds/api/standardfeeds/';
			if ($region) $feed .= $region."/";
			$feed .= $standardfeed;
			if ($category) $feed .= "_".$category;
			$feed.='?max-results='.$count;
		endif;
		return $feed;
	}
	
}